#include <iostream>

using namespace std;

struct node{
    int val;
    node *next;
};

void pasalinti_maziausia_reiksme(node * &pradzia){

    if (pradzia == NULL){
        return;
    }

    node * min_elementas = pradzia;
    node * tmp = pradzia -> next;

    while (tmp != NULL){
        if (min_elementas -> val > tmp -> val)
            min_elementas = tmp;
        tmp = tmp -> next;
    }

    tmp = pradzia;
    if (tmp == min_elementas){
        pradzia = pradzia -> next;
        delete min_elementas;
    } else {
        while (tmp != NULL){
            if (tmp -> next == min_elementas){
                tmp -> next = min_elementas -> next;
                delete min_elementas;
                break;
            }
            tmp = tmp -> next;
        }
    }
}

void isvalyti_atminti(node * &pradzia){
    node * istrinti;
    node * tmp = pradzia;

    while (tmp != NULL){
        istrinti = tmp;
        tmp = tmp -> next;
        delete istrinti;
    }

    pradzia = NULL;
}

void spausdinti_sarasa(node * pradzia){
    node * tmp = pradzia;

    while(tmp != NULL){
        cout << tmp -> val << endl;
        tmp = tmp -> next;
    }
}

int main()
{
    cout << "Iveskite vienpusio saraso elementu skaiciu : ";
    int n;
    cin >> n;

    node * pradzia = NULL;
    node * naujas = NULL;
    node * senas = NULL;

    for (int i = 0; i < n; i++){
        cout << "Iveskite elementa : ";
        int elementas;
        cin >> elementas;

        naujas = new node;
        naujas -> val = elementas;
        naujas -> next = NULL;

        if (pradzia == NULL){
            pradzia = naujas;
        }
        else
            senas -> next = naujas;
        senas = naujas;
    }

    pasalinti_maziausia_reiksme(pradzia);
    spausdinti_sarasa(pradzia);
    isvalyti_atminti(pradzia);

    return 0;
}
